#include <iostream>

class base {
	int value = 1;
public:
	void fun_a() const {
		std::cout << "Base::fun_a " << value << '\n';
	}

	void fun_b() const {
		std::cout << "Base::fun_b " << value << '\n';
	}
};

class derived : public base {
	int value = 2;
public:
	void fun_b(int x) {
		std::cout << "Derived::fun_b " << value << ' ' << x << '\n';
	}
};

int main() {
	derived d;
	d.fun_a();

	// error: fun_b() is hidden
	// d.fun_b();

	d.fun_b(7);

	d.base::fun_b();
}
