#include <iostream>

struct thing {
	thing() = default;
	thing(const thing&) { std::cout << "copy\n"; }
	thing& operator=(const thing&) {
		std::cout << "copy-assign\n";
		return *this;
	}
	~thing() = default;
};

struct base {
	thing t1;
};

struct derived : base {
	thing t2;
};

int main() {
	derived d1;
	std::cout << "---\n";
	derived d2 = d1;
	std::cout << "---\n";
	base b = d1;
	std::cout << "---\n";
}
